/******************************************************************************
 * $Id: keyboard.c,v 1.1 2006/04/18 13:00:38 jedy Exp $
 *
 * @(#)keyboard.c : prolific nand gpio keypad driver
 *
 * Copyright (c) 2002 Prolific Technology Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Prolific
 * Technology, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Prolific.
 *
 * Modification History:
 *
 ******************************************************************************/


#include <linux/config.h>
#include <linux/module.h>
#include <linux/sched.h>
#include <linux/tty.h>
#include <linux/tty_flip.h>
#include <linux/mm.h>
#include <linux/string.h>
#include <linux/init.h>
#include <linux/kbd_kern.h>
#include <linux/keyboard.h>

struct tty_struct *console_tty = NULL;

void put_queue(int ch)
{
    struct tty_struct *tty = console_tty;

	if (tty) {
		tty_insert_flip_char(tty, ch, 0);
		con_schedule_flip(tty);
	}
}


/*
 * This routine is the bottom half of the keyboard interrupt
 * routine, and runs with all interrupts enabled. It does
 * console changing, led setting and copy_to_cooked, which can
 * take a reasonably long time.
 */
static void kbd_bh(unsigned long dummy)
{
    /* do nothing */
}
DECLARE_TASKLET_DISABLED(keyboard_tasklet, kbd_bh, 0);

void handle_scancode(unsigned char scancode, int down)
{
	unsigned char keycode;
    u_short keysym;

    if (down) {
    	keycode = scancode;
        keysym = key_maps[0][keycode];
        put_queue(keysym);
    }
}
