#ifndef __OV7720_H__
#define __OV7720_H__

#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/slab.h>
#include <linux/i2c.h>
#include <linux/i2c-proc.h>
#include <linux/init.h>
#include <video/plsensor.h>

#define  OV7720_SYSCTL_READ      0x1000
#define  OV7720_SYSCTL_WRITE     0x1001

#define OV7720REG_GAIN        0x00
#define OV7720REG_BLUE        0x01
#define OV7720REG_RED         0x02
#define OV7720REG_GREEN       0x03
#define OV7720REG_COM1        0x04
#define OV7720REG_BAVG        0x05
#define OV7720REG_GAVG        0x06
#define OV7720REG_RAVG        0x07
#define OV7720REG_AECH        0x08
#define OV7720REG_COM2        0x09
#define OV7720REG_PID         0x0A
#define OV7720REG_VER         0x0B
#define OV7720REG_COM3        0x0C
#define OV7720REG_COM4        0x0D
#define OV7720REG_COM5        0x0E
#define OV7720REG_COM6        0x0F
#define OV7720REG_AEC         0x10
#define OV7720REG_CLKRC       0x11
#define OV7720REG_COM7        0x12
#define OV7720REG_COM8        0x13
#define OV7720REG_COM9        0x14
#define OV7720REG_COM10       0x15
//#define OV7720REG_RSVD        0x16
#define OV7720REG_HSTART      0x17
#define OV7720REG_HSIZE       0x18
#define OV7720REG_VSTART      0x19
#define OV7720REG_VSIZE       0x1A
#define OV7720REG_PSHFT       0x1B
#define OV7720REG_MIDH        0x1C
#define OV7720REG_MIDL        0x1D
//#define OV7720REG_RSVD        0x1E
#define OV7720REG_LAEC        0x1F
#define OV7720REG_COM11       0x20
//#define OV7720REG_RSVD        0x21
#define OV7720REG_BDBASE      0x22
#define OV7720REG_DBSTEP      0x23
#define OV7720REG_AEW         0x24
#define OV7720REG_AEB         0x25
#define OV7720REG_VPT         0x26
//#define OV7720REG_RSVD        0x27-0x28
#define OV7720REG_HOUTSIZE    0x29
#define OV7720REG_EXHCH       0x2A
#define OV7720REG_EXHCL       0x2B
#define OV7720REG_VOUTSIZE    0x2C
#define OV7720REG_ADVFL       0x2D
#define OV7720REG_ADVFH       0x2E
#define OV7720REG_YAVE        0x2F
#define OV7720REG_LUMHTH      0x30
#define OV7720REG_LUMLTH      0x31
#define OV7720REG_HREF        0x32
#define OV7720REG_DM_LNL      0x33
#define OV7720REG_DM_LNH      0x34
#define OV7720REG_ADOFF_B     0x35
#define OV7720REG_ADOFF_R     0x36
#define OV7720REG_ADOFF_GB    0x37
#define OV7720REG_ADOFF_GR    0x38
#define OV7720REG_OFF_B       0x39
#define OV7720REG_OFF_G       0x3A
#define OV7720REG_OFF_GB      0x3B
#define OV7720REG_OFF_GR      0x3C
#define OV7720REG_COM12       0x3D
#define OV7720REG_COM13       0x3E
#define OV7720REG_COM14       0x3F
#define OV7720REG_COM15       0x40
#define OV7720REG_COM16       0x41
#define OV7720REG_TGT_B       0x42
#define OV7720REG_TGT_G       0x43
#define OV7720REG_TGT_GB      0x44
#define OV7720REG_TGT_GR      0x45
#define OV7720REG_LCC0        0x46
#define OV7720REG_LCC1        0x47
#define OV7720REG_LCC2        0x48
#define OV7720REG_LCC3        0x49
#define OV7720REG_LCC4        0x4A
#define OV7720REG_LCC5        0x4B
#define OV7720REG_LCC6        0x4C
#define OV7720REG_FIXGAIN     0x4D
#define OV7720REG_AREF0       0x4E
#define OV7720REG_AREF1       0x4F
#define OV7720REG_AREF2       0x50
#define OV7720REG_AREF3       0x51
#define OV7720REG_AREF4       0x52
#define OV7720REG_AREF5       0x53
#define OV7720REG_AREF6       0x54
#define OV7720REG_AREF7       0x55
//#define OV7720REG_RSVD        0x56-0x5F
#define OV7720REG_UFIX        0x60
#define OV7720REG_VFIX        0x61
#define OV7720REG_AWBB_BLK    0x62
#define OV7720REG_AWB_CTRL0   0x63
#define OV7720REG_DSP_CTRL1   0x64
#define OV7720REG_DSP_CTRL2   0x65
#define OV7720REG_DSP_CTRL3   0x66
#define OV7720REG_DSP_CTRL4   0x67
#define OV7720REG_AWB_BIAS    0x68
#define OV7720REG_AWB_CTRL1   0x69
#define OV7720REG_AWB_CTRL2   0x6A
#define OV7720REG_AWB_CTRL3   0x6B
#define OV7720REG_AWB_CTRL4   0x6C
#define OV7720REG_AWB_CTRL5   0x6D
#define OV7720REG_AWB_CTRL6   0x6E
#define OV7720REG_AWB_CTRL7   0x6F
#define OV7720REG_AWB_CTRL8   0x70
#define OV7720REG_AWB_CTRL9   0x71
#define OV7720REG_AWB_CTRL10  0x72
#define OV7720REG_AWB_CTRL11  0x73
#define OV7720REG_AWB_CTRL12  0x74
#define OV7720REG_AWB_CTRL13  0x75
#define OV7720REG_AWB_CTRL14  0x76
#define OV7720REG_AWB_CTRL15  0x77
#define OV7720REG_AWB_CTRL16  0x78
#define OV7720REG_AWB_CTRL17  0x79
#define OV7720REG_AWB_CTRL18  0x7A
#define OV7720REG_AWB_CTRL19  0x7B
#define OV7720REG_AWB_CTRL20  0x7C
#define OV7720REG_AWB_CTRL21  0x7D
#define OV7720REG_GAM1        0x7E
#define OV7720REG_GAM2        0x7F
#define OV7720REG_GAM3        0x80
#define OV7720REG_GAM4        0x81
#define OV7720REG_GAM5        0x82
#define OV7720REG_GAM6        0x83
#define OV7720REG_GAM7        0x84
#define OV7720REG_GAM8        0x85
#define OV7720REG_GAM9        0x86
#define OV7720REG_GAM10       0x87
#define OV7720REG_GAM11       0x88
#define OV7720REG_GAM12       0x89
#define OV7720REG_GAM13       0x8A
#define OV7720REG_GAM14       0x8B
#define OV7720REG_GAM15       0x8C
#define OV7720REG_SLOP        0x8D
#define OV7720REG_DNSTH       0x8E
#define OV7720REG_EDGE0       0x8F
#define OV7720REG_EDGE1       0x90
#define OV7720REG_DNSOFF      0x91
#define OV7720REG_EDGE2       0x92
#define OV7720REG_EDGE3       0x93
#define OV7720REG_MTX1        0x94
#define OV7720REG_MTX2        0x95
#define OV7720REG_MTX3        0x96
#define OV7720REG_MTX4        0x97
#define OV7720REG_MTX5        0x98
#define OV7720REG_MTX6        0x99
#define OV7720REG_MTX_CTRL    0x9A
#define OV7720REG_BRIGHT      0x9B
#define OV7720REG_CNST        0x9C
#define OV7720REG_CNST_CTR    0x9D
#define OV7720REG_UVADJ0      0x9E
#define OV7720REG_UVADJ1      0x9F
#define OV7720REG_SCAL0       0xA0
#define OV7720REG_SCAL1       0xA1
#define OV7720REG_SCAL2       0xA2
#define OV7720REG_FIFODLYM    0xA3
#define OV7720REG_FIFODLYA    0xA4
//#define OV7720REG_RSVD        0xA5
#define OV7720REG_SDE         0xA6
#define OV7720REG_USAT        0xA7
#define OV7720REG_VSAT        0xA8
#define OV7720REG_HUE0        0xA9
#define OV7720REG_HUE1        0xAA
#define OV7720REG_SIGN        0xAB
#define OV7720REG_DSPAUTO     0xAC

#define OV7720_I2C_IOADDR     0x21

#define OV7720_PID            0x77
#define OV7720_VER            0x21

typedef struct _tagOV7720Data 
{
   int               nSysCtlID;
   struct semaphore  UpdateLock;
   char              cValid;        // !=0 if following fields are valid
   unsigned long     uLastUpdated;  // In jiffies 
   unsigned short    wReg;
   unsigned char     wRead, wWrite; // Register values
   devfs_handle_t    DevFS;
   struct i2c_client *pClient;
   PSENSOR           pSensor;
}  OV7720DATA;

typedef OV7720DATA *POV7720DATA;

#endif
