/* vi: set sw=4 ts=4: */
/*
 * Mini uptime implementation for busybox
 *
 * Copyright (C) 1999-2004 by Erik Andersen <andersen@codepoet.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

/* This version of uptime doesn't display the number of users on the system,
 * since busybox init doesn't mess with utmp.  For folks using utmp that are
 * just dying to have # of users reported, feel free to write it as some type
 * of CONFIG_FEATURE_UTMP_SUPPORT #define
 */

/* getopt not needed */


#include <stdio.h>
#include <time.h>
#include <errno.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "busybox.h"


int get_cpu_load(unsigned long *uptime, unsigned long *idletime)
{
    int fuptime = 0;
    char buf[1024];
    int rc;

    fuptime = open("/proc/uptime", O_RDONLY);

    if (fuptime <= 0)
        return fuptime;

    rc = read(fuptime, buf, 1024);
    if (rc < 0)
        return rc;

    *uptime = atol(buf);
    *idletime = atol(strchr(buf, ' '));

    close(fuptime);
    return 0;
}

extern int cpuload_main(int argc, char **argv)
{
    unsigned long up, sup, idle, sidle;

    get_cpu_load(&sup, &sidle);
    printf("\n");
    for (;;) {
        sleep(1);
        get_cpu_load(&up, &idle);
        up -=sup;
        idle -= sidle;
        printf("\rup %ld idle %ld cpu load %ld%%        ",
            up, idle, (up-idle)*100/up);
        fflush(stdout);
    }

	return EXIT_SUCCESS;
}
